#include <iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <unistd.h>
#include <vector>
#include "TGraph.h"
#include "TAxis.h"
#include "TGraphErrors.h"
#include "TCanvas.h"
#include "TFile.h"


void mkplot(int runnumber=-1,int rangemin=-1, long starttime=-1,int offline=0){

  
  
  std::stringstream v_filename[100];

  int ifile=0;
  if(runnumber>0){
    v_filename[0] << "data/DCS_log_run_" << runnumber << ".txt";
    ifile=1;
  } else {
    if(offline==0)system("rsync -av  /win/cyric/20160516_CYRIC/DCS_control/log/DCS_log_run_1* data/");
    int lastrun=runnumber;
    while(lastrun!=0){
      v_filename[ifile] << "DCS_log_run" << (lastrun+1) << ".txt";
      
      std::stringstream sscom;
      sscom << "cd data ; rm -f " << v_filename[ifile].str() << " ; ln -s `ls -tr DCS_log_run_*.txt | tail " << lastrun << " | head -1` " << v_filename[ifile].str() << "  ; cd ../";
      if(offline==0)system(sscom.str().c_str());
      ifile++;
      lastrun++;
    }


  }
  TCanvas *c1 = new TCanvas("c1","c1",1600,500);
  //  std::cout << "kkkkk " << v_filename[0].str() << std::endl;
  while(1){
    if(offline==0)system("rsync -av  /win/cyric/20160516_CYRIC/DCS_control/log/DCS_log_run_1* data/");
    //    system("cd data ; rm -f DCS_log_run.txt; ln -s `ls -tr | tail -1` DCS_log_run.txt ; cd ../");
    
    double num, ison, date, time, year, month, day, hour, minute, second, temp1, temp2;
    std::vector<double> v_num, v_ison, v_date, v_time, v_year, v_month, v_day, v_hour, v_minute, v_second, v_temp1, v_temp2,v_datetime;

    for(unsigned int ii=0;ii<ifile;ii++){
      //      std::cout << "  aaaa  " << v_filename[ii].str() << std::endl;
    }
    for(int ithfile=0;ithfile<ifile;ithfile++){
      //      std::cout << " bbbbbb " << v_filename[ithfile].str() << std::endl;
      std::ifstream inputfile(("data/"+v_filename[ithfile].str()).c_str());

      while(!inputfile.eof()){
	inputfile >> num >> temp1 >> temp2 >> ison >>  date >>  time;
	
	modf(date/10000,&year); date-=year*10000;
	modf(date/100,&month); date-=month*100;
	day=date;
	
	modf(time/10000,&hour); time-=hour*10000;
	modf(time/100,&minute); time-=minute*100;
	second=time;
	
	if(year<2000){
	  //	  std::cout << num << " " << temp1 << " " << ison << " " << temp2 << " " <<   "(" << year <<" " << month <<" "<< day<< " " << hour <<" " << minute << " " << second<< ")"<< std::endl;
	  break;
	}

	TDatime t0(year,month,day,hour,minute,second);
	
	v_num.push_back(num); v_ison.push_back(ison*10); v_year.push_back(year); v_month.push_back(month); v_day.push_back(day); v_hour.push_back(hour); v_minute.push_back(minute); v_second.push_back(second); v_temp1.push_back(temp1); v_temp2.push_back(temp2); v_datetime.push_back(t0.Convert());
      }
      inputfile.close();
    }
    
    TLegend *leg = new TLegend(0.7,0.7,0.9,0.93);
    leg->SetBorderSize(0);
    leg->SetFillStyle(0);
    
    TGraph *gr_temp1=new TGraph(v_datetime.size(),&v_datetime[0],&v_temp1[0]);
    gr_temp1->GetXaxis()->SetTimeFormat("%d-%H:%M");
    //  gr_temp1->GetXaxis()->SetTimeFormat("%d %H:%M:%S");
    gr_temp1->GetXaxis()->SetTimeDisplay(1);
    //    double xmin=gr_temp1->GetXaxis()->GetXmin();
    //    double xmax=gr_temp1->GetXaxis()->GetXmax();
    double xmin=v_datetime[0];
    double xmax=v_datetime[v_datetime.size()-1];
    if(rangemin!=-1){
      if(starttime!=-1){
	double year,month,day,hour,minute,second;
	modf(starttime/10000000000,&year); starttime-=year*10000000000;
	modf(starttime/100000000,&month); starttime-=month*100000000;
	modf(starttime/1000000,&day); starttime-=day*1000000;
	modf(starttime/10000,&hour); starttime-=hour*10000;
	modf(starttime/100,&minute); starttime-=minute*100;
	second=starttime;
	TDatime t0(year,month,day,hour,minute,second);
	xmax=t0.Convert()+rangemin*60;
	std::cout << starttime <<  "(" << year <<" " << month <<" "<< day<< " " << hour <<" " << minute << " " << second<< ")"<< std::endl;
      }else{
	xmax=v_datetime[v_datetime.size()-2];
      }
      xmin=xmax-rangemin*60;
      xmax+=rangemin*60*0.1;
      xmin-=rangemin*60*0.1;
    }
    double mintemp=100;
    double maxtemp=-100;
    for(unsigned int ii=0; ii<v_temp1.size();ii++){
      if(v_datetime[ii]<xmin)continue;
      if(mintemp>v_temp1[ii])mintemp=v_temp1[ii];
      if(mintemp>v_temp2[ii])mintemp=v_temp2[ii];
      if(maxtemp<v_temp1[ii])maxtemp=v_temp1[ii];
      if(maxtemp<v_temp2[ii])maxtemp=v_temp2[ii];
    }
    double ymin=mintemp-(maxtemp-mintemp)*0.15;
    maxtemp=maxtemp<0?0:maxtemp;
    double ymax=maxtemp+(maxtemp-mintemp)*0.15;

    if(ymin<-50)ymin=-50;
    if(ymax>50)ymax=50;
    gr_temp1->GetXaxis()->SetRangeUser(xmin,xmax);
    gr_temp1->GetYaxis()->SetRangeUser(ymin,ymax);
    gr_temp1->GetXaxis()->SetNdivisions(1010);
    gr_temp1->GetXaxis()->SetTitle("Date and Time [DD-HH:MM]");
    gr_temp1->GetYaxis()->SetTitle("Temperature [#circC]");
    gr_temp1->GetXaxis()->SetTimeOffset(0);
    gr_temp1->SetMarkerColor(4);
    //  gr_temp1->Draw("AP");
    leg->AddEntry(gr_temp1,"Temperature up","p");

    TGraph *gr_temp2=new TGraph(v_datetime.size(),&v_datetime[0],&v_temp2[0]);
    gr_temp2->GetXaxis()->SetTimeFormat("%Y/%m/%d %h:%M:%s");
    gr_temp2->GetXaxis()->SetTimeDisplay(1);
    gr_temp2->GetXaxis()->SetTimeOffset(0);
    gr_temp2->SetMarkerColor(3);
    leg->AddEntry(gr_temp2,"Temperature down","p");

    TGraph *gr_onoff=new TGraph(v_datetime.size(),&v_datetime[0],&v_ison[0]);
    gr_onoff->GetXaxis()->SetTimeFormat("%Y/%m/%d %h:%M:%s");
    gr_onoff->GetXaxis()->SetTimeDisplay(1);
    gr_onoff->GetXaxis()->SetTimeOffset(0);
    gr_onoff->SetMarkerColor(2);
    gr_onoff->SetLineColor(2);
    leg->AddEntry(gr_onoff,"Liquid valve status","l");

    c1->Clear();
    c1->SetGridx(1);
    c1->SetGridy(1);
    gr_temp1->Draw("APg");
    gr_temp2->Draw("Psame");
    gr_onoff->Draw("lsame");
    leg->Draw();
    c1->Update();
    c1->Print("tempout.eps");
    c1->Print("tempout.png");
    if(runnumber>0)break;
    if(offline==1)break;
    sleep(10);
  }
}
